# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from roch_msgs/PSDEvent.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class PSDEvent(genpy.Message):
  _md5sum = "638b618316102a845053a2e4172b4a5d"
  _type = "roch_msgs/PSDEvent"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Provides a ult sensor event.
# This message is generated whenever a particular cliff sensor signals that the
# robot approaches or moves away from a cliff.
# Note that, despite cliff field on SensorState messages, state field is not a
# bitmask, but the new state of a single sensor.

# psd sensor
uint8 LEFT   = 0
uint8 CENTER = 1
uint8 RIGHT  = 2

# psd sensor state
uint8 NORMAL = 0
uint8 NEAR = 1

uint8 leftSensor
uint8 leftState

# distance to floor when cliff was detected
float64 leftBottom

uint8 centerSensor
uint8 centerState

# distance to floor when cliff was detected
float64 centerBottom

uint8 rightSensor
uint8 rightState

# distance to floor when cliff was detected
float64 rightBottom
"""
  # Pseudo-constants
  LEFT = 0
  CENTER = 1
  RIGHT = 2
  NORMAL = 0
  NEAR = 1

  __slots__ = ['leftSensor','leftState','leftBottom','centerSensor','centerState','centerBottom','rightSensor','rightState','rightBottom']
  _slot_types = ['uint8','uint8','float64','uint8','uint8','float64','uint8','uint8','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       leftSensor,leftState,leftBottom,centerSensor,centerState,centerBottom,rightSensor,rightState,rightBottom

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PSDEvent, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.leftSensor is None:
        self.leftSensor = 0
      if self.leftState is None:
        self.leftState = 0
      if self.leftBottom is None:
        self.leftBottom = 0.
      if self.centerSensor is None:
        self.centerSensor = 0
      if self.centerState is None:
        self.centerState = 0
      if self.centerBottom is None:
        self.centerBottom = 0.
      if self.rightSensor is None:
        self.rightSensor = 0
      if self.rightState is None:
        self.rightState = 0
      if self.rightBottom is None:
        self.rightBottom = 0.
    else:
      self.leftSensor = 0
      self.leftState = 0
      self.leftBottom = 0.
      self.centerSensor = 0
      self.centerState = 0
      self.centerBottom = 0.
      self.rightSensor = 0
      self.rightState = 0
      self.rightBottom = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2Bd2Bd2Bd().pack(_x.leftSensor, _x.leftState, _x.leftBottom, _x.centerSensor, _x.centerState, _x.centerBottom, _x.rightSensor, _x.rightState, _x.rightBottom))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 30
      (_x.leftSensor, _x.leftState, _x.leftBottom, _x.centerSensor, _x.centerState, _x.centerBottom, _x.rightSensor, _x.rightState, _x.rightBottom,) = _get_struct_2Bd2Bd2Bd().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2Bd2Bd2Bd().pack(_x.leftSensor, _x.leftState, _x.leftBottom, _x.centerSensor, _x.centerState, _x.centerBottom, _x.rightSensor, _x.rightState, _x.rightBottom))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 30
      (_x.leftSensor, _x.leftState, _x.leftBottom, _x.centerSensor, _x.centerState, _x.centerBottom, _x.rightSensor, _x.rightState, _x.rightBottom,) = _get_struct_2Bd2Bd2Bd().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2Bd2Bd2Bd = None
def _get_struct_2Bd2Bd2Bd():
    global _struct_2Bd2Bd2Bd
    if _struct_2Bd2Bd2Bd is None:
        _struct_2Bd2Bd2Bd = struct.Struct("<2Bd2Bd2Bd")
    return _struct_2Bd2Bd2Bd
